/******************************************************************************* 
 * Copyright (c) 2017, Real-Time Technology Solutions, Inc. All Rights Reserved. 
 *******************************************************************************/
package com.rttsweb.querysurge.rest;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;

public class JerseyRestClient {

	/**
	 * @param args
	 * 
	 * http://services.groupkt.com/country/search?text=un
	 * @throws URISyntaxException 
	 * @throws IOException 
	 * @throws JsonMappingException 
	 * @throws JsonParseException
	 */
	
	
	public static void main(String[] args) throws URISyntaxException, JsonParseException, JsonMappingException, IOException {
        String tempUrl = args[0];
        String csvFilePath = args[1];
        String jsonResultArrayRoot = args[2];
        String jsonArrayElementNames = args[3];
        boolean verbose = false;
        
        if (args.length == 5) {
        	verbose = Boolean.valueOf(args[4]);
        }
        
        restQuery(tempUrl, csvFilePath, jsonResultArrayRoot, jsonArrayElementNames, verbose);
	}
	
	public static void restQuery(String webserviceURL, String csvFilePath, String jsonResultArrayRoot, String jsonArrayElementNames, boolean verbose) throws URISyntaxException, JsonParseException, JsonMappingException, IOException {
		// handle the json array element names - these will be column names
		String [] jsonArrayElements = jsonArrayElementNames.split(",");
		// create a handler
		JerseyRestHandler rest = new JerseyRestHandler(jsonResultArrayRoot, jsonArrayElements);
		// handle the REST URL
		String url = (!webserviceURL.startsWith(JerseyRestHandler.HTTPPROTOCOL)) ? JerseyRestHandler.HTTPPROTOCOL + webserviceURL : webserviceURL;
        URI uri = new URI(url);
        
        String resp = null;
        if ((uri.getPath() != null) && (uri.getQuery() != null)) {
        	String query = uri.getQuery();
        	String [] kvpairs = query.split("&");
        	String [] searchKeys = new String[kvpairs.length];
        	String [] vals = new String[kvpairs.length];
        	for (int n = 0; n < kvpairs.length; n++) {
        		String [] kvpair = kvpairs[n].split("=");
        		searchKeys[n] = kvpair[0];
        		vals[n] = kvpair[1];
        	}
        	// make the request and trap the json response
        	resp = rest.getRestResponse(uri.getHost(), uri.getPath(), searchKeys, vals);
        } else {
        	// a helper method for simple REST URLs
        	resp = rest.getRestResponse(uri.getHost(), uri.getPath());
        }
        // verbose = print the json
        if (verbose) {
        	System.out.println(resp);
        }
        // convert the json to a csv file
        rest.jsonToCsv(resp, csvFilePath);
	}
}
